﻿using Xamarin.Forms;
using System;
using Syncfusion.SfCalendar.XForms;
namespace FlickeringTest
{
    public partial class FlickeringTestPage : ContentPage
    {
		int i = 0;
		DateTime month = new DateTime();
		Label lbl, lbl1;

		public FlickeringTestPage()
        {
            InitializeComponent();
            MonthViewSettings month = new MonthViewSettings();
            month.DayHeaderBackgroundColor = Color.Black;
            month.DayHeaderTextColor = Color.White;
            month.PreviousMonthTextColor = Color.Gray;
            month.CurrentMonthTextColor = Color.White;
            month.PreviousMonthBackgroundColor = Color.Black;
            month.BorderColor = Color.Black;
            month.CurrentMonthBackgroundColor = Color.Black;
            calendar.MonthViewSettings = month;
            calendar.OnMonthCellLoaded+=HandleMonthCellEventHandler;
			CalendarEventCollection collection = new CalendarEventCollection();
			collection.Add(new CalendarInlineEvent() { Subject = "Meeting", StartTime = new DateTime(2017, 7, 1), EndTime = new DateTime(2017, 7, 5) });
			collection.Add(new CalendarInlineEvent() { Subject = "Meeting", StartTime = new DateTime(2017, 7, 22), EndTime = new DateTime(2017, 7, 22) });
			collection.Add(new CalendarInlineEvent() { Subject = "Meeting", StartTime = new DateTime(2017, 7, 12), EndTime = new DateTime(2017, 7, 13) });
			collection.Add(new CalendarInlineEvent() { Subject = "Meeting", StartTime = new DateTime(2017, 7, 15), EndTime = new DateTime(2017, 7, 18) });
            calendar.DataSource = collection;
            calendar.ShowInlineEvents = true;
			

		}

        void HandleMonthCellEventHandler(object sender, MonthCell args)
        {
			if (Device.RuntimePlatform == "Android")
			{

				bool call = false;
                for (int i = 0; i < calendar.DataSource.Count; i++)
				{
                    if ((args.Date.Date.CompareTo(calendar.DataSource[i].StartTime.Date) == 0 || args.Date.Date.CompareTo(calendar.DataSource[i].StartTime.Date) == 1) && (args.Date.Date.CompareTo(calendar.DataSource[i].EndTime.Date) == 0 || args.Date.Date.CompareTo(calendar.DataSource[i].EndTime.Date) == -1))
					{
						call = true;
					}

				}
				i++;

				string str = args.Date.ToString("dd");
				if (i == 1)
				{
					month = args.Date.AddDays(21);
				}
				if (call)
				{
					if (month.Month == args.Date.Month)
					{

                        lbl = new Label() { Text = str, FontSize = 15, HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.Center, TextColor = Color.White };
                        lbl1 = new Label() { Text = "_", FontSize = 20, HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.End, TextColor = Color.White };
					}

					else
					{
                        lbl = new Label() { Text = str, FontSize = 15, HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.Center, TextColor = Color.White };
                        lbl1 = new Label() { Text = "_", FontSize = 20, HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.End, TextColor = Color.White };

					}
					Grid DynamicGrid = new Grid();
					DynamicGrid.HorizontalOptions = LayoutOptions.Center;
					DynamicGrid.VerticalOptions = LayoutOptions.Center;
					RowDefinition gridRow1 = new RowDefinition();
					gridRow1.Height = new GridLength(10);
					RowDefinition gridRow2 = new RowDefinition();
					gridRow2.Height = new GridLength(15);
					RowDefinition gridRow3 = new RowDefinition();
					gridRow3.Height = new GridLength(10);
					DynamicGrid.RowDefinitions.Add(gridRow1);
					DynamicGrid.RowDefinitions.Add(gridRow2);
					DynamicGrid.RowDefinitions.Add(gridRow3);
					Grid.SetRow(lbl, 1);
					Grid.SetRow(lbl1, 2);
					DynamicGrid.Children.Add(lbl1);
					DynamicGrid.Children.Add(lbl);
					args.View = DynamicGrid;
				}
				else
				{
					if (month.Month == args.Date.Month)
					{
                        lbl = new Label() { Text = str, FontSize = 15, HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.Center, TextColor = Color.White };
					}

					else
					{
                        lbl = new Label() { Text = str, FontSize = 15, HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.Center, TextColor = Color.WhiteSmoke };
					}
					args.View = lbl;
				}
				if (i == 42)
				{
					i = 0;
				}

			}
		}
	}
}
